## xmutil 1.2

=== CMakeLists.txt ===
#
# Copyright 2021 Xilinx Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

# cmake needs this line
cmake_minimum_required(VERSION 3.5)

# Define project name
project(ddr-qos)

SET(CMAKE_INSTALL_PREFIX $ENV{OECORE_TARGET_SYSROOT})
set(CMAKE_C_STANDARD 99)

include_directories(include)
file(GLOB SOURCES "src/*.c")
SET(INSTALL_PATH "usr/bin")

#set(EXECUTABLE_OUTPUT_PATH  ${PROJECT_SOURCE_DIR})
# Declare the executable target built from your sources
add_executable(ddr-qos ${SOURCES})
install(TARGETS ddr-qos RUNTIME DESTINATION ${INSTALL_PATH})

set(VERSION "1.0")
set(CPACK_PACKAGE_VERSION ${VERSION})
set(CPACK_PACKAGE_NAME "ddr-qos")
set(CPACK_PACKAGE_RELEASE 1)
set(CPACK_PACKAGE_CONTACT "amamidal@xilinx.com")
set(CPACK_PACKAGE_VENDOR "xilinx")
set(CPACK_PACKAGE_RELEASE 1)
set(CPACK_DEBIAN_PACKAGE_ARCHITECTURE "arm64")
set(CPACK_RPM_PACKAGE_ARCHITECTURE ${CMAKE_SYSTEM_PROCESSOR})
set(CPACK_PACKAGING_INSTALL_PREFIX "/")
set(CPACK_PACKAGE_FILE_NAME "${CPACK_PACKAGE_NAME}-${CPACK_PACKAGE_VERSION}-${CPACK_PACKAGE_RELEASE}.${CMAKE_SYSTEM_PROCESSOR}")
set(CPACK_RPM_SPEC_MORE_DEFINE "%define _build_id_links none")
include(CPack)

=== debian/changelog ===
xmutil (1:1.2) jammy; urgency=medium

  * Update the new upstream versioning v1.2
    - Fix 'pwrctl' failure in KV260
  * Update watch script
    - platformstats removed from the watch script
      since it is a separate package now

 -- Talha Can Havadar <talha.can.havadar@canonical.com>  Thu, 02 Nov 2023 17:29:31 +0100

xmutil (2023.2-0ubuntu1) jammy; urgency=medium

  * Update to new upstream version 2023.2
    - All submodules axi-qos, ddr-qos and image-update
      are also updated to 2023.2

 -- Talha Can Havadar <talha.can.havadar@canonical.com>  Thu, 02 Nov 2023 17:16:50 +0100

xmutil (2023.1+20230620-0xlnx1) jammy; urgency=medium

  * Update to new upstream 56c808f

 -- Talha Can Havadar <talha.can.havadar@canonical.com>  Tue, 20 Jun 2023 20:30:05 +0000

xmutil (2023.1+20230411-0xlnx3) jammy; urgency=medium

  * d/p/fix-getpkgs-error.patch: Add ignore-errors by default to getpkgs command

 -- Talha Can Havadar <talha.can.havadar@canonical.com>  Tue, 20 Jun 2023 07:41:53 +0000

xmutil (2023.1+20230411-0xlnx2) jammy; urgency=medium

  * d/p/fix-image-update-install.patch: Add image-update bin to /usr/bin

 -- Talha Can Havadar <talha.can.havadar@canonical.com>  Sat, 17 Jun 2023 08:34:53 +0000

xmutil (2023.1+20230411-0xlnx1) jammy; urgency=medium

  * Update to new upstream
    - Update xmutil to 485b1c5
    - Update axi-qos, ddr-qos and image-update to 2023.1
    - Remove d/p/image-update-rename-fru-print.patch
    - Use freeipmi instead of fru-print
    - Add support for K24

 -- Talha Can Havadar <talha.can.havadar@canonical.com>  Wed, 14 Jun 2023 11:22:33 +0000

xmutil (2022.1+20220928-0xlnx1) jammy; urgency=medium

  * Update to new upstream
    - Update xmutil to 49ffc83
      . Use renamed xlnx-platformstats instead of original platformstats
    - Remove platformstats since it is already packaged independently
      as xlnx-platformstats

 -- Hon Ming Hui <honming.hui@canonical.com>  Wed, 28 Sep 2022 01:06:36 +0100

xmutil (2022.1+20220726-0xlnx2) jammy; urgency=medium

  * New patch, fix-dp-unbind-and-desktop-disable: cherry pick 3d667ed to
    fix DP unbind and desktop enable/disable.

 -- Loïc Minier <loic.minier@ubuntu.com>  Fri, 29 Jul 2022 16:29:50 +0000

xmutil (2022.1+20220726-0xlnx1) jammy; urgency=medium

  * New upstream snapshots from 2022-07-26:
    - Update xmutil to a6bacc8.
      . Drop patches xmutil-add-makefile, xmutil-rename-fru-print,
        xmutil-fix-unloadapp-arguments, add-ubuntu-support-in-getpkgs,
        cherry-pick-update-apt-query: merged upstream.
    - Update linux_image-update to 170a84f.
      . Drop patch image-update-add-install-target: merged upstream.
    - Update platformstats to 616ce5a.
      . Drop patches platformstats-fix-clean,
        platformstats-add-install-target, platformstats-add-makefile,
        cherry-pick-meminfo-parsing-fix: merged upstream.
      . Build-depend on swig which now gets called during build, and on
        python3-dev for Python.h.
    - No updates to axi-qos and ddr-qos – no upstream changes.

 -- Loïc Minier <loic.minier@ubuntu.com>  Tue, 26 Jul 2022 13:00:34 +0000

xmutil (2022.1-0ubuntu0~xlnx9) jammy; urgency=medium

  * New patch cherry-pick-update-apt-query: cherry-pick 1edb8c7 to
    search for xmutil to search for Xilinx Apps demos with the xlnx-app-
    prefix instead of packagegroup-.

 -- Loïc Minier <loic.minier@ubuntu.com>  Tue, 14 Jun 2022 15:14:49 +0000

xmutil (2022.1-0ubuntu0~xlnx8) jammy; urgency=medium

  * New patch cherry-pick-meminfo-parsing-fix: cherry-pick c7b5621 to fix
    parsing /proc/meminfo; LP: #1973047.

 -- Loïc Minier <loic.minier@ubuntu.com>  Sun, 22 May 2022 19:50:50 +0000

xmutil (2022.1-0ubuntu0~xlnx7) jammy; urgency=medium

  * New patch image-update-rename-fru-print to call fru-print rather than
    fru-print.py from image-update/image_update.c.

 -- Loïc Minier <loic.minier@ubuntu.com>  Mon, 16 May 2022 16:41:43 +0000

xmutil (2022.1-0ubuntu0~xlnx6) jammy; urgency=medium

  * Cherry-pick a couple of fixes from upstream as patches:
    - 05396d9 Add ubuntu support in getpkgs
    - a4bc19d xmutil: fix unloadapp arguments
    - Add python3-distro dependency for xmutil.

 -- Loïc Minier <loic.minier@ubuntu.com>  Tue, 10 May 2022 14:47:42 +0000

xmutil (2022.1-0ubuntu0~xlnx5) jammy; urgency=medium

  * Add missing cmake dependency and watch entry

 -- John Toomey <john.toomey@amd.com>  Thu, 28 Apr 2022 09:07:28 +0000

xmutil (2022.1-0ubuntu0~xlnx4) jammy; urgency=medium

  * Add axi-qos and ddr-qos

 -- John Toomey <john.toomey@amd.com>  Tue, 26 Apr 2022 10:06:10 +0000

xmutil (2022.1-0ubuntu0~xlnx3) jammy; urgency=medium

  * Recommend fru-print for "xmutil boardid".

 -- Loïc Minier <loic.minier@ubuntu.com>  Fri, 22 Apr 2022 00:28:55 +0000

xmutil (2022.1-0ubuntu0~xlnx2) jammy; urgency=medium

  * Add initial watch file. * Add patch xmutil-rename-fru-print to use fru-print instead of
    fru-print.py.

 -- Loïc Minier <loic.minier@ubuntu.com>  Fri, 22 Apr 2022 00:16:12 +0000

xmutil (2022.1-0ubuntu0~xlnx1) jammy; urgency=medium

  * Initial release based on Xilinx' xmutil 2022.1, platformstats 2022.1 and linux-image_update 2022.1.

 -- Loïc Minier <loic.minier@ubuntu.com>  Wed, 20 Apr 2022 21:56:32 +0000

=== debian/watch ===
version=4
# * in opts:
#   - filenamemangle renames the downloaded tarball into a more correct name
#   - component sets the secondary upstream tarball component name
# * debian: xmutil is compared against the version in debian/changelog
# * same: other components are expected to have the same version
# * github tags are searched for versions
opts="filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/xmutil-$1\.tar\.gz/" \
  https://github.com/Xilinx/xmutil/tags \
  .*/v@ANY_VERSION@@ARCHIVE_EXT@ \
  debian
# linux-image_update
opts="filenamemangle=s/.+\/xilinx_v?(\d\S+)\.tar\.gz/linux-image_update-$1\.tar\.gz/, component=image-update" \
  https://github.com/Xilinx/linux-image_update/tags \
  .*/xilinx_v@ANY_VERSION@@ARCHIVE_EXT@ 2023.2
# axi-qos with same version
opts="filenamemangle=s/.+\/xilinx_v?(\d\S+)\.tar\.gz/axi-qos-$1\.tar\.gz/, component=axi-qos" \
  https://github.com/Xilinx/axi-qos/tags \
  .*/xilinx_v@ANY_VERSION@@ARCHIVE_EXT@ 2023.2
# ddr-qos with same version
opts="filenamemangle=s/.+\/xilinx_v?(\d\S+)\.tar\.gz/ddr-qos-$1\.tar\.gz/, component=ddr-qos" \
  https://github.com/Xilinx/ddr-qos/tags \
  .*/xilinx_v@ANY_VERSION@@ARCHIVE_EXT@ 2023.2

## xmutil 1.2ubuntu1

=== debian/changelog ===
xmutil (1:1.2ubuntu1) jammy; urgency=medium

  * Update image-update to new upstream v1.1
    - Enables support to revision 2 boards

 -- Talha Can Havadar <talha.can.havadar@canonical.com>  Thu, 25 Jan 2024 16:16:04 +0100

=== debian/control ===
Source: xmutil
Standards-Version: 4.6.0
Maintainer: Loïc Minier <loic.minier@ubuntu.com>
Priority: optional
Section: utils
Build-Depends: cmake, debhelper-compat (= 13), swig, python3-dev

Package: xmutil
Architecture: arm64
Depends: ${misc:Depends}, ${shlibs:Depends}, python3, python3-distro,
 xlnx-platformstats,
# for kria-pwrctl
 python3-periphery,
Recommends:
# for i2ctransfer (som-pwrctl, used in pwrctl)
 i2c-tools,
# for dfx-mgr-client (used in listapps, loadapp, unloadapp)
 dfx-mgr,
# for boardid
 freeipmi(>= 1.6.9-2ubuntu0.22.04.1),
Description: Wrapper around utilities for Xilinx System-on-Modules
 Xmutil is a frontend to a series of scripts useful on Xilinx
 System-on-Modules.
 .
 "xmutil bootfw_status" and "xmutil bootfw_update" allow checking and updating
 the contents of the QSPI flash (requires root or permission to read mtd
 devices).
 .
 "xmutil listapps", "xmutil loadapp" and "xmutil unloadapp" allow querying,
 loading and removing apps through dfx-mgr (requires dfx-mgr).
 .
 "xmutil platformstats" prints performance related statistics.
 .
 "xmutil pwrctl" controls the power of the Programmable Logic (PL) tile
 (requires i2c-tools).

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure $@
	dh_auto_configure --sourcedirectory=image-update $@
	dh_auto_configure --sourcedirectory=axi-qos --builddirectory=axi-qos_build $@
	dh_auto_configure --sourcedirectory=ddr-qos --builddirectory=ddr-qos_build $@

override_dh_auto_build:
	dh_auto_build $@
	dh_auto_build --sourcedirectory=image-update $@
	dh_auto_build --sourcedirectory=axi-qos --builddirectory=axi-qos_build $@
	dh_auto_build --sourcedirectory=ddr-qos --builddirectory=ddr-qos_build $@

override_dh_auto_clean:
	dh_auto_clean $@
	dh_auto_clean --sourcedirectory=image-update $@
	dh_auto_clean --sourcedirectory=axi-qos --builddirectory=axi-qos_build $@
	dh_auto_clean --sourcedirectory=ddr-qos --builddirectory=ddr-qos_build $@

override_dh_auto_install:
	dh_auto_install $@
	dh_auto_install --sourcedirectory=image-update $@
	dh_auto_install --sourcedirectory=axi-qos --builddirectory=axi-qos_build $@
	dh_auto_install --sourcedirectory=ddr-qos --builddirectory=ddr-qos_build $@

=== debian/watch ===
--- 
+++ 
@@ -10,9 +10,9 @@
   .*/v@ANY_VERSION@@ARCHIVE_EXT@ \
   debian
 # linux-image_update
-opts="filenamemangle=s/.+\/xilinx_v?(\d\S+)\.tar\.gz/linux-image_update-$1\.tar\.gz/, component=image-update" \
+opts="filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/linux-image_update-$1\.tar\.gz/, component=image-update" \
   https://github.com/Xilinx/linux-image_update/tags \
-  .*/xilinx_v@ANY_VERSION@@ARCHIVE_EXT@ 2023.2
+  .*/v@ANY_VERSION@@ARCHIVE_EXT@ 1.1
 # axi-qos with same version
 opts="filenamemangle=s/.+\/xilinx_v?(\d\S+)\.tar\.gz/axi-qos-$1\.tar\.gz/, component=axi-qos" \
   https://github.com/Xilinx/axi-qos/tags \

## xmutil 2022.1

=== Makefile ===
# SPDX-License-Identifier: MIT
#
# Copyright (c) 2021 Xilinx, Inc.
#

CROSS_COMPILE ?= aarch64-linux-gnu-
CC ?= $(CROSS_COMPILE)gcc
EXEC := image_update
c_SOURCES := $(wildcard *.c)
INCLUDES := $(wildcard *.h)
OBJS := $(patsubst %.c, %.o, $(c_SOURCES))

all: $(EXEC)

$(EXEC): $(c_SOURCES)
	$(CC) $< -o $@

clean:
	rm -rf $(OBJS) image_update

=== app/Makefile ===
.PHONY:	clean

CC ?=  gcc
CFLAGS ?= -Wall -Wextra
LDFLAGS ?= 
LIBDIR = ../src
INCLUDEDIR = ../include/platformstats
SOURCES = main.c
APPS = main
APPSTMPS = main.out

all: build

build: $(APPSTMPS)

%.out: %.o
	$(CC) $(LDFLAGS) -o platformstats main.o -L$(LIBDIR) -lplatformstats

%.o: %.c
	$(CC) -I$(INCLUDEDIR) $(CFLAGS) -c main.c -o main.o

clean:
	rm -f $(APPS) *.o

=== python-bindings/Makefile ===
.PHONY:	clean

#Dynamic loading for C
CC ?= gcc
CFLAGS ?= -fPIC -Wall -Wextra
LDFLAGS ?=
LIBS = -L../src -L. -lplatformstats
INCLUDES = -I../include/platformstats

#Python
PYTHON_INCLUDE ?= -I/usr/include/python3.7m/ -lpython3.7m
PYTHON_SO = .so

#Swig
SWIG ?= swig
SWIGOPT ?= 
IWRAP      = $(INTERFACE:.i=_wrap.i)
ISRCS      = $(IWRAP:.i=.c)
IOBJS      = $(IWRAP:.i=.o)

INTERFACE = platformstats_bindings.i
PYBIND_LIB ?= _pbindings.so 

all: $(PYBIND_LIB)

$(ISRCS): $(INTERFACE)
	$(SWIG) -python $<

$(PYBIND_LIB): $(ISRCS)
	$(CC) $(CFLAGS) $(LDFLAGS) -shared $(ISRCS) -o $(PYBIND_LIB) $(LIBS) $(INCLUDES) $(PYTHON_INCLUDE)

clean:
	rm -f *.o *.so* *_wrap* *.pyc *.py __pycache__  platformstats

=== src/Makefile ===
.PHONY:	clean

CC ?=  gcc
CP = cp
CFLAGS 	+= -Wall
LDFLAGS += -shared

SOURCES = $(shell echo *.c)
HEADERS = $(shell echo *.h)
OBJECTS = $(SOURCES:.c=.o)
INCLUDEDIR = ../include
MAJOR = 1
MINOR = 0
VERSION = $(MAJOR).$(MINOR)
NAME := platformstats

all: include lib$(NAME).so

clean:
	rm -f $(OBJECTS) *.so *.so.*
	rm -rf $(INCLUDEDIR)

include:
	mkdir $(INCLUDEDIR)/platformstats -p
	$(CP) $(HEADERS) $(INCLUDEDIR)/platformstats

lib$(NAME).so.$(VERSION): $(OBJECTS)
	$(CC) $(LDFLAGS) $^ -Wl,-soname,lib$(NAME).so.$(MAJOR) -o lib$(NAME).so.$(VERSION)

lib$(NAME).so: lib$(NAME).so.$(VERSION)
	rm -f lib$(NAME).so.$(MAJOR) lib$(NAME).so
	ln -s lib$(NAME).so.$(VERSION) lib$(NAME).so.$(MAJOR)
	ln -s lib$(NAME).so.$(MAJOR) lib$(NAME).so

%.o: %.c include
	$(CC) $(CFLAGS) -I$(INCLUDEDIR) -I$(INCLUDEDIR)/platformstats -c -fPIC $< -o $@

=== debian/control ===
--- 
+++ 
@@ -3,21 +3,18 @@
 Maintainer: Loïc Minier <loic.minier@ubuntu.com>
 Priority: optional
 Section: utils
-Build-Depends: cmake, debhelper-compat (= 13), swig, python3-dev
+Build-Depends: cmake, debhelper-compat (= 13)
 
 Package: xmutil
 Architecture: arm64
-Depends: ${misc:Depends}, ${shlibs:Depends}, python3, python3-distro,
- xlnx-platformstats,
-# for kria-pwrctl
- python3-periphery,
+Depends: ${misc:Depends}, ${shlibs:Depends}, python3, python3-distro
 Recommends:
 # for i2ctransfer (som-pwrctl, used in pwrctl)
  i2c-tools,
 # for dfx-mgr-client (used in listapps, loadapp, unloadapp)
  dfx-mgr,
 # for boardid
- freeipmi(>= 1.6.9-2ubuntu0.22.04.1),
+ fru-print,
 Description: Wrapper around utilities for Xilinx System-on-Modules
  Xmutil is a frontend to a series of scripts useful on Xilinx
  System-on-Modules.
@@ -33,3 +30,4 @@
  .
  "xmutil pwrctl" controls the power of the Programmable Logic (PL) tile
  (requires i2c-tools).
+

## xmutil 2022.1+20220726

=== CMakeLists.txt ===
--- 
+++ 
@@ -14,27 +14,33 @@
 # limitations under the License.
 #
 
+
 # cmake needs this line
 cmake_minimum_required(VERSION 3.5)
 
 # Define project name
-project(ddr-qos)
+project(axi-qos)
 
 SET(CMAKE_INSTALL_PREFIX $ENV{OECORE_TARGET_SYSROOT})
 set(CMAKE_C_STANDARD 99)
+
+SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-narrowing -fpermissive -rdynamic -Wl,--no-undefined" )
+SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pthread -std=c++14")
+
+include_directories(include)
 
 include_directories(include)
 file(GLOB SOURCES "src/*.c")
 SET(INSTALL_PATH "usr/bin")
 
-#set(EXECUTABLE_OUTPUT_PATH  ${PROJECT_SOURCE_DIR})
 # Declare the executable target built from your sources
-add_executable(ddr-qos ${SOURCES})
-install(TARGETS ddr-qos RUNTIME DESTINATION ${INSTALL_PATH})
+add_executable(axi-qos ${SOURCES})
+
+install(TARGETS axi-qos RUNTIME DESTINATION ${INSTALL_PATH})
 
 set(VERSION "1.0")
 set(CPACK_PACKAGE_VERSION ${VERSION})
-set(CPACK_PACKAGE_NAME "ddr-qos")
+set(CPACK_PACKAGE_NAME "axi-qos")
 set(CPACK_PACKAGE_RELEASE 1)
 set(CPACK_PACKAGE_CONTACT "amamidal@xilinx.com")
 set(CPACK_PACKAGE_VENDOR "xilinx")

=== app/Makefile ===
--- 
+++ 
@@ -1,17 +1,23 @@
-.PHONY:	clean
+.PHONY:	clean all build install
 
 CC ?=  gcc
+INSTALL_PROGRAM ?= install
 CFLAGS ?= -Wall -Wextra
 LDFLAGS ?= 
 LIBDIR = ../src
 INCLUDEDIR = ../include/platformstats
 SOURCES = main.c
-APPS = main
+APPS = platformstats
 APPSTMPS = main.out
+
+bindir ?= /usr/bin
 
 all: build
 
 build: $(APPSTMPS)
+
+install: $(APPSTMPS)
+	$(INSTALL_PROGRAM) -D -m 755 platformstats $(DESTDIR)$(bindir)/platformstats
 
 %.out: %.o
 	$(CC) $(LDFLAGS) -o platformstats main.o -L$(LIBDIR) -lplatformstats

=== python-bindings/Makefile ===
.PHONY:	clean all install

#Dynamic loading for C
CC ?= gcc
INSTALL_PROGRAM ?= install
CFLAGS += -fPIC -Wall -Wextra
LDFLAGS += -shared -L../src -L.
LDLIBS += -lplatformstats -lpython$(PYTHON_BASEVERSION)
INCLUDE_DIR = ../include/platformstats

incdir ?= /usr/include
libdir ?= /usr/lib

#Python
PYTHON_BASEVERSION ?= 3.10
PYTHON_DIR ?= python${PYTHON_BASEVERSION}
PYTHON_INCLUDE_DIR ?= ${incdir}/$(PYTHON_DIR)
PYTHON_SITEPACKAGES_DIR ?= ${libdir}/$(PYTHON_DIR)

#Swig
SWIG ?= swig
SWIGOPT ?=
IWRAP      = $(INTERFACE:.i=_wrap.i)
ISRCS      = $(IWRAP:.i=.c)
IOBJS      = $(IWRAP:.i=.o)

INTERFACE = platformstats_bindings.i
PYBIND_LIB ?= _platformstats.so

all: $(PYBIND_LIB)

$(ISRCS): $(INTERFACE)
	$(SWIG) -python $<

$(PYBIND_LIB): $(ISRCS)
	$(CC) $(CFLAGS) $(LDFLAGS) $(ISRCS) -o $(PYBIND_LIB) $(LDLIBS) -I$(INCLUDE_DIR) -I$(PYTHON_INCLUDE_DIR)

clean:
	rm -f *.o *.so* *_wrap* *.pyc *.py __pycache__  platformstats

install: $(PYBIND_LIB)
	$(INSTALL_PROGRAM) -d $(DESTDIR)${PYTHON_SITEPACKAGES_DIR}/platformstats
	$(INSTALL_PROGRAM) -m 0644 platformstats.py $(DESTDIR)${PYTHON_SITEPACKAGES_DIR}/platformstats
	$(INSTALL_PROGRAM) -m 0644 _platformstats.so $(DESTDIR)${PYTHON_SITEPACKAGES_DIR}/platformstats

=== src/Makefile ===
--- 
+++ 
@@ -2,8 +2,12 @@
 
 CC ?=  gcc
 CP = cp
+INSTALL_PROGRAM ?= install
 CFLAGS 	+= -Wall
 LDFLAGS += -shared
+
+libdir ?= /usr/lib
+includedir ?= /usr/include
 
 SOURCES = $(shell echo *.c)
 HEADERS = $(shell echo *.h)
@@ -15,6 +19,11 @@
 NAME := platformstats
 
 all: include lib$(NAME).so
+
+install: all
+	$(INSTALL_PROGRAM) -D -m 644 platformstats.h  $(DESTDIR)$(includedir)/platformstats.h
+	$(INSTALL_PROGRAM) -D -m 644 lib$(NAME).so.$(VERSION) $(DESTDIR)$(libdir)/lib$(NAME).so.$(VERSION)
+	$(CP) -d lib$(NAME).so.$(MAJOR) lib$(NAME).so $(DESTDIR)$(libdir)/
 
 clean:
 	rm -f $(OBJECTS) *.so *.so.*

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Maintainer: Loïc Minier <loic.minier@ubuntu.com>
 Priority: optional
 Section: utils
-Build-Depends: cmake, debhelper-compat (= 13)
+Build-Depends: cmake, debhelper-compat (= 13), swig, python3-dev
 
 Package: xmutil
 Architecture: arm64

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure $@
	dh_auto_configure --sourcedirectory=axi-qos --builddirectory=axi-qos_build $@
	dh_auto_configure --sourcedirectory=ddr-qos --builddirectory=ddr-qos_build $@

override_dh_auto_build:
	dh_auto_build $@
	dh_auto_build --sourcedirectory=image-update $@
	dh_auto_build --sourcedirectory=platformstats $@
	dh_auto_build --sourcedirectory=axi-qos --builddirectory=axi-qos_build $@
	dh_auto_build --sourcedirectory=ddr-qos --builddirectory=ddr-qos_build $@

override_dh_auto_clean:
	dh_auto_clean $@
	dh_auto_clean --sourcedirectory=image-update $@
	dh_auto_clean --sourcedirectory=platformstats $@
	dh_auto_clean --sourcedirectory=axi-qos --builddirectory=axi-qos_build $@
	dh_auto_clean --sourcedirectory=ddr-qos --builddirectory=ddr-qos_build $@

override_dh_auto_install:
	dh_auto_install $@
	dh_auto_install --sourcedirectory=image-update $@
	# XXX not sure why this doesn't work
	#dh_auto_install --sourcedirectory=platformstats $@
	$(MAKE) -C platformstats install DESTDIR=$(CURDIR)/debian/xmutil/
	dh_auto_install --sourcedirectory=axi-qos --builddirectory=axi-qos_build $@
	dh_auto_install --sourcedirectory=ddr-qos --builddirectory=ddr-qos_build $@

=== debian/watch ===
version=4
# * in opts:
#   - filenamemangle renames the downloaded tarball into a more correct name
#   - component sets the secondary upstream tarball component name
# * debian: xmutil is compared against the version in debian/changelog
# * same: other components are expected to have the same version
# * github tags are searched for versions
opts="filenamemangle=s/.+\/xilinx_v?(\d\S+)\.tar\.gz/xmutil-$1\.tar\.gz/" \
  https://github.com/Xilinx/xmutil/tags \
  .*/xilinx_v@ANY_VERSION@@ARCHIVE_EXT@ \
  debian
# linux-image_update
opts="filenamemangle=s/.+\/xilinx_v?(\d\S+)\.tar\.gz/linux-image_update-$1\.tar\.gz/, component=image-update" \
  https://github.com/Xilinx/linux-image_update/tags \
  .*/xilinx_v@ANY_VERSION@@ARCHIVE_EXT@ \
  same
# platformstats with same version
opts="filenamemangle=s/.+\/xilinx_v?(\d\S+)\.tar\.gz/platformstats-$1\.tar\.gz/, component=platformstats" \
  https://github.com/Xilinx/platformstats/tags \
  .*/xilinx_v@ANY_VERSION@@ARCHIVE_EXT@ \
  same
# axi-qos with same version
opts="filenamemangle=s/.+\/xilinx_v?(\d\S+)\.tar\.gz/axi-qos-$1\.tar\.gz/, component=axi-qos" \
  https://github.com/Xilinx/axi-qos/tags \
  .*/xilinx_v@ANY_VERSION@@ARCHIVE_EXT@ \
  same
# ddr-qos with same version
opts="filenamemangle=s/.+\/xilinx_v?(\d\S+)\.tar\.gz/ddr-qos-$1\.tar\.gz/, component=ddr-qos" \
  https://github.com/Xilinx/ddr-qos/tags \
  .*/xilinx_v@ANY_VERSION@@ARCHIVE_EXT@ \
  same

## xmutil 2022.1+20220928

=== Makefile ===
--- 
+++ 
@@ -5,6 +5,8 @@
 
 CROSS_COMPILE ?= aarch64-linux-gnu-
 CC ?= $(CROSS_COMPILE)gcc
+INSTALL_PROGRAM ?= install
+bindir ?= /usr/bin
 EXEC := image_update
 c_SOURCES := $(wildcard *.c)
 INCLUDES := $(wildcard *.h)
@@ -15,5 +17,8 @@
 $(EXEC): $(c_SOURCES)
 	$(CC) $< -o $@
 
+install: $(EXEC)
+	$(INSTALL_PROGRAM) -D -m 755 $(EXEC) $(DESTDIR)$(bindir)/$(EXEC)
+
 clean:
 	rm -rf $(OBJS) image_update

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,8 @@
 
 Package: xmutil
 Architecture: arm64
-Depends: ${misc:Depends}, ${shlibs:Depends}, python3, python3-distro
+Depends: ${misc:Depends}, ${shlibs:Depends}, python3, python3-distro, 
+ xlnx-platformstats,
 Recommends:
 # for i2ctransfer (som-pwrctl, used in pwrctl)
  i2c-tools,

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure $@
	dh_auto_configure --sourcedirectory=axi-qos --builddirectory=axi-qos_build $@
	dh_auto_configure --sourcedirectory=ddr-qos --builddirectory=ddr-qos_build $@

override_dh_auto_build:
	dh_auto_build $@
	dh_auto_build --sourcedirectory=image-update $@
	dh_auto_build --sourcedirectory=axi-qos --builddirectory=axi-qos_build $@
	dh_auto_build --sourcedirectory=ddr-qos --builddirectory=ddr-qos_build $@

override_dh_auto_clean:
	dh_auto_clean $@
	dh_auto_clean --sourcedirectory=image-update $@
	dh_auto_clean --sourcedirectory=axi-qos --builddirectory=axi-qos_build $@
	dh_auto_clean --sourcedirectory=ddr-qos --builddirectory=ddr-qos_build $@

override_dh_auto_install:
	dh_auto_install $@
	dh_auto_install --sourcedirectory=image-update $@
	dh_auto_install --sourcedirectory=axi-qos --builddirectory=axi-qos_build $@
	dh_auto_install --sourcedirectory=ddr-qos --builddirectory=ddr-qos_build $@

## xmutil 2023.1+20230620

=== Makefile ===
# SPDX-License-Identifier: MIT
#
# Copyright (c) 2021 Xilinx, Inc.
# Copyright (c) 2022 - 2023 Advanced Micro Devices, Inc.  All Rights Reserved.
#

INSTALL_PROGRAM ?= install
bindir ?= /usr/bin

all:

install:
	$(INSTALL_PROGRAM) -D -m 755 xmutil $(DESTDIR)$(bindir)/xmutil

clean:
